<?php
/*
Plugin Name: porDefecto
Plugin URI: http://www.difusor.org/pordefecto/
Description: This plugin question the complacent attitude of those who use browsers that are installed by default in their operating system.
Author: http://www.difusor.org/
Version: 0.1.2
Author URI: http://www.difusor.org/
*/ 

/* No licens, no copyright, no nothing make whatever. */

$pd_dom = "pd_dom";
/**
* Convert bbcode.
* @return string
*/
function bbcode($text) {
		$pd_options = get_option('pordefecto_options');
		$string = $pd_options["$text"];
		$bbreplace = array('/(\[[Bb]\])(.+)(\[\/[Bb]\])/','/(\[[Ii]\])(.+)(\[\/[Ii]\])/','/(\[url=)(.+)(\])(.+)(\[\/url\])/','/(\[img=)(.+)(\])(.+)(\[\/img\])/','/(\[s=)(.+)(\])(.+)(\[\/s\])/');
		$bbreplacements = array ('<strong>\\2</strong>','<em>\\2</em>','<a href="\\2" title="\\4">\\4</a>','<img src="\\2" alt="\\4" />', '<span class="\\2">\\4</span>');
		$string = preg_replace($bbreplace,$bbreplacements,$string);
		print nl2br($string);	
		}
/**		
* Add css for preview in admin
* @return string
*/
function pd_admin_style() {
    $url = get_settings('siteurl');
    $url = $url . '/wp-content/plugins/pordefecto/css/style.css';
    echo '<link rel="stylesheet" type="text/css" href="' . $url . '" />';
}

add_action('admin_head', 'pd_admin_style');
		
if (!class_exists('pordefecto')) {
    class pordefecto	{
		
		/**
		* @var string   The name the options are saved under in the database.
		*/
		var $adminOptionsName = "pordefecto_options";
		

		
		/**
		* PHP 4 Compatible Constructor
		*/
		function pordefecto(){$this->__construct();}
		
		/**
		* PHP 5 Constructor
		*/		
		function __construct(){

		//add_action("init", "pd_init");
		add_action("admin_menu", array(&$this,"add_admin_pages"));
		add_action('wp_head', array(&$this,'wp_head_intercept'));
		add_action("send_headers", array(&$this,"add_cookie"));
		add_action("init", array(&$this,"add_scripts"));
		add_action("wp_head", array(&$this,"add_css"));
		
			$this->adminOptions = $this->getAdminOptions();

		}
		
		/**
		* Retrieves the options from the database.
		* @return array
		*/
		function getAdminOptions() {
		$adminOptions = array(
		"pd_jq" => "false",
		"pd_time_allowed_1" => "4000",
		"pd_ie_win" => "[img=http://www.difusor.org/wp-content/plugins/pordefecto/css/pordefecto.jpg]Image description (alt text)[/img]\n\n[s=normalit]Your current browser is:[/s]\n\n\n[s=bigit][b]Internet Explorer / Windows[/b][/s]\n[s=normalit](is your operating system default browser)[/s]",
		"pd_sf_mac" => "[img=http://www.difusor.org/wp-content/plugins/pordefecto/css/pordefecto.jpg]Image description (alt text)[/img]\n\n[s=normalit]Your current browser is:[/s]\n\n\n[s=bigit][b]Safari / Macintosh[/b][/s]\n[s=normalit](is your operating system default browser)[/s]",
		"pd_time_2_disapear" => "5000",
		"pd_new_url" => "home");
		$savedOptions = get_option($this->adminOptionsName);
		if (!empty($savedOptions)) {
			foreach ($savedOptions as $key => $option) {
				$adminOptions[$key] = $option;
			}
		}
		update_option($this->adminOptionsName, $adminOptions);
		return $adminOptions;
		}
		
		
		/**
		* Saves the admin options to the database.
		*/
		function saveAdminOptions(){
			update_option($this->adminOptionsName, $this->adminOptions);
		}
		
		function add_admin_pages(){
				add_submenu_page('options-general.php', "Pordefecto", "porDefecto", 10, "Pordefecto", array(&$this,"output_sub_admin_page_0"));
		}
		
		/**
		* Outputs the HTML for the admin sub page.
		*/
		function output_sub_admin_page_0(){
			
		
			if (isset($_POST['update_options'])) {
				$this->adminOptions['pd_jq'] = (get_magic_quotes_gpc()) ? stripslashes($_POST['pd_jq']) : $_POST['pd_jq'];
				$this->adminOptions['pd_time_allowed_1'] = (get_magic_quotes_gpc()) ? stripslashes($_POST['pd_time_allowed_1']) : $_POST['pd_time_allowed_1'];
				$this->adminOptions['pd_ie_win'] = (get_magic_quotes_gpc()) ? stripslashes($_POST['pd_ie_win']) : $_POST['pd_ie_win'];
				$this->adminOptions['pd_sf_mac'] = (get_magic_quotes_gpc()) ? stripslashes($_POST['pd_sf_mac']) : $_POST['pd_sf_mac'];
				$this->adminOptions['pd_time_2_disapear'] = (get_magic_quotes_gpc()) ? stripslashes($_POST['pd_time_2_disapear']) : $_POST['pd_time_2_disapear'];
				$this->adminOptions['pd_new_url'] = (get_magic_quotes_gpc()) ? stripslashes($_POST['pd_new_url']) : $_POST['pd_new_url'];
				
				$this->saveAdminOptions();
				echo "<div id=\"message\" class=\"updated fade\"><p><strong>" . __("Updated Options.", $pd_dom) . "</strong></p></div>";
			}
			if (isset($_POST['reset_options'])) {
				$this->adminOptions['pd_jq'] = "false";
				$this->adminOptions['pd_time_allowed_1'] = "4000";
				$this->adminOptions['pd_ie_win'] = "[img=http://www.difusor.org/wp-content/plugins/pordefecto/css/pordefecto.jpg]Image description (alt text)[/img]\n\n[s=normalit]Your current browser is:[/s]\n\n\n[s=bigit][b]Internet Explorer / Windows[/b][/s]\n[s=normalit](is your operating system default browser)[/s]";
				$this->adminOptions['pd_sf_mac'] = "[img=http://www.difusor.org/wp-content/plugins/pordefecto/css/pordefecto.jpg]Image description (alt text)[/img]\n\n[s=normalit]Your current browser is:[/s]\n\n\n[s=bigit][b]Safari / Macintosh[/b][/s]\n[s=normalit](is your operating system default browser)[/s]";
				$this->adminOptions['pd_time_2_disapear'] = "5000";
				$this->adminOptions['pd_new_url'] = "home";
				$this->saveAdminOptions();
				echo "<div id=\"message\" class=\"updated fade\"><p><strong>" . __("Default text loaded.", $pd_dom) . "</strong></p></div>";
			} 

		$pd_options = get_option('pordefecto_options');
		?>
        <div class="wrap">
        <h2><?php echo __("porDefecto Options", $pd_dom); ?></h2>
        <p><?php echo __("This plugin question the complacent attitude of those who use browsers that are installed by default in their operating system.", $pd_dom); ?></p>
        <h3><?php echo __("Settings", $pd_dom); ?></h3>
        <form method="post" name="form1" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
            <table cellspacing="0" class="form-table">
			<tbody>
                <tr valign="top">
                    <th scope="row">
                        <label for="pd_jq"><?php echo __("Use provided jQuery", $pd_dom); ?></label>
                    </th>
                    <td>
                    <select name="pd_jq" id="pd_jq" style="width: 100px">
                        <option value="true"<?php selected('true', $pd_options['pd_jq']); ?>><?php echo __("Yes", $pd_dom); ?></option>
                        <option value="false"<?php selected('false', $pd_options['pd_jq']); ?>><?php echo __("No", $pd_dom); ?></option>
                    </select>
                    <?php echo __("If the message is not showing select <strong>Yes</strong> to add the jQuery library.", $pd_dom); ?>
                  
                        
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">
                       <label for="pd_time_allowed_1"> <?php echo __("Time until fade in", $pd_dom); ?></label>				

                    </th>
                    <td>
                        <input type="text" name="pd_time_allowed_1" id="pd_time_allowed_1" style="width:50px;" value="<?php echo $pd_options['pd_time_allowed_1']; ?>"/>
                        <?php echo __("Ex.: <strong>1000</strong> is one second.", $pd_dom); ?>
                    </td>

                   
                </tr>
                <tr valign="top">
                    <th scope="row">
                        <label for="pd_ie_win"><?php echo __("Internet Explorer Windows text", $pd_dom); ?></label>
                    </th>
                    <td>
                        <textarea name="pd_ie_win" rows="5" style="width:100%;"><?php echo $pd_options['pd_ie_win']; ?></textarea>
                        <?php echo __("Can be used bbCode like: [b]Bold[/b], [i]Cursive[/i], [url=http://...]Text to link[/url], [img=http://....]Image description (alt text)[/img]<br /> Advanced coding: to define the style of text you can use [s=class]text[/s]", $pd_dom); ?>
                    </td>
                    
                </tr>
                <tr valign="top">
                    <th scope="row">
                        <label for="pd_sf_mac"><?php echo __("Safari Macintosh text", $pd_dom); ?></label>
                    </th>
                    <td>
                        <textarea name="pd_sf_mac" id="pd_sf_mac" rows="5" style="width:100%;"><?php echo $pd_options['pd_sf_mac']; ?></textarea>
                        <?php echo __("Can be used bbCode like: [b]Bold[/b], [i]Cursive[/i], [url=http://...]Text to link[/url], [img=http://....]Image description (alt text)[/img]<br /> Advanced coding: to define the style of text you can use [s=class]text[/s]", $pd_dom); ?>
                    </td>
                </tr>
                <tr valign="top">
                    <th scope="row">
                        <label for="pd_time_2_disapear"><?php echo __("Time to fade to black", $pd_dom); ?></label>
                    </th>
                    <td>
                        <input type="text" name="pd_time_2_disapear" id="pd_time_2_disapear" style="width:50px;" value="<?php echo $pd_options['pd_time_2_disapear']; ?>"/>
                        <?php echo __("Ex: <strong>1000</strong> is one second, 0 message remains.", $pd_dom); ?>
                    </td>
                   
                </tr>
                <tr valign="top">
                    <th scope="row">
                        <label for="pd_new_url"><?php echo __("Desired redirection", $pd_dom); ?></label>
                    </th>
                    <td>
                        <input type="text" name="pd_new_url" id="pd_new_url" style="width:40%;" value="<?php echo $pd_options['pd_new_url']; ?>"/>
                        <?php echo __("Ex: <strong>home</strong> leads to blog home page, <strong>http://...</strong> leads to the selected url.", $pd_dom); ?>
                    </td>
                   
                </tr>
            </tbody>
            </table>
            <p class="submit">
                <input type="submit" name="update_options" value="<?php echo __("Update", $pd_dom); ?>"/> 
                <input type="submit" name="reset_options" value="<?php echo __("Default", $pd_dom); ?>"/>
            </p>
        </form>    
        
        <h2>Example Previews</h2>
        <table style="width:100%">
            <thead>
                <tr>
                    <th scope="col">
                        Internet Explorer / Windows <?php echo __("message"); ?>
                    </th>
                    <th scope="col">
                        Safari / Macintosh message <?php echo __("message"); ?>
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td style="width:50%">
                        <div class="bann-admin">
                            <p><?php bbcode(pd_ie_win); ?></p>
                        </div>
                    </td>
                    <td style="width:50%">
                        <div class="bann-admin">
                            <p><?php bbcode(pd_sf_mac); ?></p>
                        </div>
                    </td>
                </tr>
            </tbody>
        </table>
        </div>   <!--/wrap--> 
            
		<?php
		} 
		
		/**
		* Called by the action wp_head
		*/
		function wp_head_intercept(){
			global $pd_dom;
			load_plugin_textdomain($pd_dom,"/wp-content/plugins/pordefecto/lang/");
				
			//Define wich browser
			define (BROWSER, getenv("HTTP_USER_AGENT"));	
			
			if (isset($_COOKIE['hasbeen'])) {/*nothing happend*/} else { //begin the monster
         		

				
			if (preg_match("/MSIE/i",BROWSER) && preg_match("/Windows/i",BROWSER)) {	
			$pd_options = get_option('pordefecto_options');

			 ?>
             <script type="text/javascript">
			 	function delayer(){window.location = "<?php if ($pd_options['pd_new_url']=='home') {echo bloginfo('url');} else { echo $pd_options['pd_new_url'];} ?>"}
				$(document).ready(function() {
					$('#bann').hide();
					setTimeout (function(){
						$('#bann').fadeIn(1000);
					 },<?php echo $pd_options['pd_time_allowed_1']; ?>); 
					<?php if ($pd_options['pd_time_2_disapear']=='0'){} else { ?>
					setTimeout (function(){
						$('#bann p').fadeOut(1000);
					 },<?php echo $pd_options['pd_time_allowed_1']; ?> + <?php echo $pd_options['pd_time_2_disapear']; ?> );
					setTimeout('delayer()', <?php echo $pd_options['pd_time_allowed_1']; ?> + <?php echo $pd_options['pd_time_2_disapear']; ?> + 1000);
					<?php } // end if no fade out ?>
				});
			 </script>
			<div id="bann" style="display:none"><p><?php echo bbcode(pd_ie_win); ?></p></div>
			<?php } //end if win
			if (preg_match("/Safari/i",BROWSER) && preg_match("/Mac/i",BROWSER)) {	
			$pd_options = get_option('pordefecto_options');
			?>
            <script type="text/javascript">
				function delayer(){window.location = "<?php if ($pd_options['pd_new_url']=='home') {echo bloginfo('url');} else { echo $pd_options['pd_new_url'];} ?>"}
				$(document).ready(function() {
					$('#bann').hide();
					setTimeout (function(){
						$('#bann').fadeIn(1000);
					 },<?php echo $pd_options['pd_time_allowed_1']; ?>); 
					<?php if ($pd_options['pd_time_2_disapear']=='0'){} else { ?>
					setTimeout (function(){
						$('#bann p').fadeOut(1000);
					 },<?php echo $pd_options['pd_time_allowed_1']; ?> + <?php echo $pd_options['pd_time_2_disapear']; ?> ); 
					setTimeout('delayer()', <?php echo $pd_options['pd_time_allowed_1']; ?> + <?php echo $pd_options['pd_time_2_disapear']; ?> + 1000);
					<?php } // end if no fade out ?>
				});
			 </script>
			<div id="bann" style="display:none"><p><?php echo bbcode(pd_sf_mac); ?></p></div>
		<?php
			}//end if is mac
		}// en if no cookie
		} 
		
		/**
		* Call by the actio send_headers
		*/
		function add_cookie(){
			
			define (BROWSER, getenv("HTTP_USER_AGENT"));	
			if (preg_match("/MSIE/i",BROWSER) && preg_match("/Windows/i",BROWSER) || preg_match("/Safari/i",BROWSER) && preg_match("/Mac/i",BROWSER)) {	
				if (isset($_COOKIE['hasbeen'])) {/*nothing happend*/} else { setcookie( "hasbeen", "cookie", 0, "/", "");} // set the cookie 
			}
			
		}
		
		
		/**
		* Tells WordPress to load the scripts
		*/
		function add_scripts(){
			//Define wich browser
			
			
			define (BROWSER, getenv("HTTP_USER_AGENT"));	
			if (preg_match("/MSIE/i",BROWSER) && preg_match("/Windows/i",BROWSER) || preg_match("/Safari/i",BROWSER) && preg_match("/Mac/i",BROWSER)) {	
			//if (isset($_COOKIE['firsttime'])) {/*nothing happend*/} else { setcookie("firsttime");} // set the cookie	
				$pd_options = get_option('pordefecto_options');
				if ($pd_options['pd_jq'] == "true"){
					wp_enqueue_script('pordefecto_script', '/wp-content/plugins/pordefecto/js/jquery.js', NULL , 0.1); 
				}
			}
			
			
		}
		
		/**
		* Adds a link to the stylesheet to the header
		*/
		function add_css(){
			//Define wich browser
			define (BROWSER, getenv("HTTP_USER_AGENT"));	
			if (preg_match("/MSIE/i",BROWSER) && preg_match("/Windows/i",BROWSER) || preg_match("/Safari/i",BROWSER) && preg_match("/Mac/i",BROWSER)) {	
				echo '<link rel="stylesheet" href="'.get_bloginfo('wpurl').'/wp-content/plugins/pordefecto/css/style.css" type="text/css" media="screen"  />'; 
			}
		}
		

    }
}

//instantiate the class
if (class_exists('pordefecto')) {
	$pordefecto = new pordefecto();
}
?>